# demonstration of using the Vaunix LDA DLL from Tcl
# March 2014
# Note that the ANSI C version of the LDA dll is used. In this example it is renamed as a reminder.
# Be sure to either change the name in the script or rename the DLL to match
source dll_tcl.tcl

::dll::load VNX_atten_ansi -> atn

::atn::cmd "int fnLDA_GetNumDevices()"
::atn::cmd "void fnLDA_SetTestMode(int)"
::atn::cmd "int fnLDA_InitDevice(int)"
::atn::cmd "int fnLDA_SetAttenuation(int, int)"
::atn::cmd "int fnLDA_CloseDevice(int)"

# find out how many Lab Brick Attenuators are attached
set w1 [::atn::fnLDA_GetNumDevices]
puts "There are $w1 attenuators connected"

# open up the first attenuator so we can use it
set w2 [::atn::fnLDA_InitDevice 1]
puts "InitDevice returns $w2"

# set the attenuation to 10db
set w3 [::atn::fnLDA_SetAttenuation 1 40]
puts "SetAttenuation returns $w3"

# close the device since we are done with it
set w4 [::atn::fnLDA_CloseDevice 1]
puts "CloseDevice returns $w3"